  
#ifndef _msmetadata_cmpt_h_
#define _msmetadata_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/ms/msmetadata_forward.h>

using namespace std;

namespace casac {
           


   class  msmetadata  {
       public :


         ~msmetadata();
         msmetadata();

         std::vector<int> almaspws( bool  chavg=false,  bool  fdm=false,  bool  sqld=false,  bool  tdm=false,  bool  wvr=false,  bool  complement=false);

         record* antennadiameter( const variant & antenna = variant());

         std::vector<int> antennaids( const variant & name = variant(),  const variant & mindiameter = variant(),  const variant & maxdiameter = variant(),  int  obsid=-1);

         std::vector<std::string> antennanames( const variant & antennaids = variant());

         record* antennaoffset( const variant & which = variant());

         record* antennaposition( const variant & which = variant());

         std::vector<std::string> antennastations( const variant & which = variant(),  int  obsid=-1);

         std::vector<int> antennasforscan( int  scan=-1,  int  obsid=-1,  int  arrayid=-1);

         variant* bandwidths( const variant & spw = variant());

         int baseband( int  spw);

         variant* baselines();

         std::vector<int> chanavgspws();

         std::vector<double>chaneffbws( int  spw,  const string& unit=string(""),  bool  asvel=false);

         std::vector<double>chanfreqs( int  spw,  const string& unit=string("Hz"));

         std::vector<double>chanres( int  spw,  const string& unit=string(""),  bool  asvel=false);

         std::vector<double>chanwidths( int  spw,  const string& unit=string("Hz"));

         bool close();

         variant* corrprodsforpol( int  pol=-1);

         std::vector<int> corrtypesforpol( int  pol=-1);

         std::vector<int> datadescids( int  spw=-1,  int  pol=-1);

         bool done();

         record* effexposuretime();

         record* exposuretime( int  scan=0,  int  spwid=0,  int  polid=-1,  int  obsid=0,  int  arrayid=0);

         std::vector<int> fdmspws();

         std::vector<std::string> fieldnames();

         variant* fieldsforintent( const string& intent=string(""),  bool  asnames=false);

         std::vector<int> fieldsforname( const string& name=string(""));

         variant* fieldsforscan( int  scan=-1,  bool  asnames=false,  int  obsid=-1,  int  arrayid=-1);

         variant* fieldsforscans( const std::vector<int>& scans=std::vector<int>() ,  bool  asnames=false,  int  obsid=-1,  int  arrayid=-1,  bool  asmap=false);

         variant* fieldsforsource( int  source=-1,  bool  asnames=false);

         record* fieldsforsources( bool  asnames=false);

         variant* fieldsforspw( int  spw=-1,  bool  asnames=false);

         std::vector<int> fieldsfortimes(
			  double time=-1, 
			  double tol=0);

         std::vector<std::string> intents();

         std::vector<std::string> intentsforfield( const variant & field = variant());

         std::vector<std::string> intentsforscan( int  scan=-1,  int  obsid=-1,  int  arrayid=-1);

         std::vector<std::string> intentsforspw( int  spw=-1);

         double meanfreq( int  spw,  const string& unit=string("Hz"));

         string name();

         std::vector<std::string> namesforfields( const variant & fieldids = variant());

         std::vector<std::string> namesforspws( const variant & spwids = variant());

         int nantennas();

         int narrays();

         int nbaselines( bool  ac=false);

         int nchan( int  spw);

         variant* ncorrforpol( int  polid=-1);

         int nfields();

         int nobservations();

         int nspw( bool  includewvr=true);

         int nstates();

         int nscans();

         int nsources();

         double nrows( bool  autoc=true,  bool  flagged=true);

         std::vector<std::string> observers();

         std::vector<std::string> observatorynames();

         record* observatoryposition( int  which=0);

         bool open( const string& msfile=string(""),  float  maxcache=50);

         record* phasecenter( int  fieldid=0,  const record& epoch=initialize_record("") );

         record* pointingdirection( int  rownum=0,  bool  interpolate=false,  int  initialrow=0);

         variant* polidfordatadesc( int  ddid=-1);

         std::vector<std::string> projects();

         record* propermotions();

         record* refdir( const variant & field = variant(),  const record& epoch=initialize_record("") );

         record* reffreq( int  spw=-1);

         variant* restfreqs( int  sourceid=0,  int  spw=0);

         std::vector<int> scannumbers( int  obsid=-1,  int  arrayid=-1);

         std::vector<int> scansforfield( const variant & intent = variant(),  int  obsid=-1,  int  arrayid=-1);

         record* scansforfields( int  obsid=0,  int  arrayid=0);

         std::vector<int> scansforintent( const string& intent=string(""),  int  obsid=-1,  int  arrayid=-1);

         std::vector<int> scansforspw( int  spw=-1,  int  obsid=-1,  int  arrayid=-1);

         record* scansforspws( int  obsid=0,  int  arrayid=0);

         std::vector<int> scansforstate( int  state=-1,  int  obsid=-1,  int  arrayid=-1);

         std::vector<int> scansfortimes(
			  double time=-1, 
			  double tol=0,  int  obsid=-1,  int  arrayid=-1);

         std::vector<std::string> schedule( int  obsid=-1);

         int sideband( int  spw);

         record* sourcedirs();

         record* sourcetimes();

         int sourceidforfield( int  field=-1);

         std::vector<int> sourceidsfromsourcetable();

         std::vector<std::string> sourcenames();

         variant* spwsforbaseband( int  baseband=-1,  const string& sqldmode=string("include"));

         variant* spwfordatadesc( int  ddid=-1);

         std::vector<int> spwsforfield( const variant & field = variant());

         record* spwsforfields();

         std::vector<int> spwsforintent( const string& intent=string(""));

         record* spwsfornames( const variant & spwids = variant());

         std::vector<int> spwsforscan( int  scan=-1,  int  obsid=-1,  int  arrayid=-1);

         record* spwsforscans( int  obsid=0,  int  arrayid=0);

         std::vector<int> statesforscan( int  scan=-1,  int  obsid=-1,  int  arrayid=-1);

         record* statesforscans( int  obsid=0,  int  arrayid=0);

         record* summary();

         std::vector<int> tdmspws();

         record* timerangeforobs( int  obsid=-1);

         std::vector<double>timesforfield( int  field=-1);

         std::vector<double>timesforintent( const string& intent=string(""));

         variant* timesforscan( int  scan=-1,  int  obsid=-1,  int  arrayid=-1,  bool  perspw=false);

         std::vector<double>timesforscans( const variant & scans= variant(),  int  obsid=-1,  int  arrayid=-1);

         variant* timesforspws( const variant & spw= variant());

         variant* transitions( int  sourceid=0,  int  spw=0);

         std::vector<int> wvrspws( bool  complement=false);


      private :
#include <tools/ms/msmetadata_private.h>
   }; 

 
}
#endif
