  
#ifndef _sidebandseparator_cmpt_h_
#define _sidebandseparator_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/synthesis/sidebandseparator_forward.h>

using namespace std;

namespace casac {
           


   class  sidebandseparator  {
       public :


         ~sidebandseparator();
         sidebandseparator();

         bool open( const std::vector<std::string>& imagename=std::vector<string>(1, ""));

         bool close();

         bool done();

         bool setshift( const std::vector<double>& shift=std::vector<double>() ,  bool  signal=true);

         bool setlimit(
			  double threshold=0.2);

         bool setboth( bool  getbothside=false);

         bool set_imageband_frequency(
			  double refpix=0.0,  const Quantity& refval=Quantity(std::vector<double>(1, -1.0),"Hz"));

         bool setsolveother( bool  subtract_from_other=false);

         bool separate(const  string& outfile=string(""),  bool  overwrite=false);


      private :
#include <tools/synthesis/sidebandseparator_private.h>
   }; 

 
}
#endif
