  
#ifndef _utils_cmpt_h_
#define _utils_cmpt_h_

#include <vector>
#include <string>
#include <complex>
#include <stdcasa/record.h>
#include <tools/casaswig_types.h>
#include <casa/Exceptions/Error.h>
#include <tools/utils/utils_forward.h>

using namespace std;

namespace casac {
           


   class  utils  {
       public :


         ~utils();
         utils();

         bool verify( const record& input=initialize_record("") ,  const variant & xmldescriptor= variant(),  bool  throwexecpt=false);

         bool setconstraints( const variant & xmldescriptor= variant());

         bool verifyparam( const record& param=initialize_record("") );

         variant* expandparam(const  string& name=string(""),  const variant & value = variant());

         record* torecord(const  string& input);

         string toxml( const record& input=initialize_record("") ,  bool  asfile=false, const  string& filename=string("recordas.xml"));

         string getrc(const  string& rcvar=string(""));

         bool removetable( const std::vector<std::string>& tablenames=std::vector<string>(1, ""));

         record* tableinfo(const  string& tablename=string(""));

         std::vector<std::string> lockedtables();

         record* hostinfo();

         string c_exception();

         void c_exception_clear();

         string _crash_reporter_initialize(const  string& crashDumpDirectory, const  string& crashDumpPosterApplication, const  string& crashPostingUrl, const  string& logFile);

         bool _trigger_segfault( int  faultType=0);

         bool initialize( const std::vector<std::string>& default_path);

         std::vector<std::string> defaultpath();

         bool setpath( const std::vector<std::string>& dirs=std::vector<string>(1, ""));

         std::vector<std::string> getpath();

         void clearpath();

         string resolve(const  string& path=string(""));

         record* registry();

         record* services();

         void shutdown();

         std::vector<int> version();

         string version_desc();

         string version_info();

         string version_string();

         bool compare_version(const  string& comparitor,  const std::vector<int>& vec);


      private :
#include <tools/utils/utils_private.h>
   }; 

 
}
#endif
